package nl.maartenvr98.PluginTemplate;

import nl.maartenvr98.PluginKit.PluginKit;
import nl.maartenvr98.PluginKit.config.ConfigFile;
import nl.maartenvr98.PluginKit.log.Log;
import nl.maartenvr98.PluginTemplate.commands.MyCommand;
import nl.maartenvr98.PluginTemplate.config.MainConfig;
import nl.maartenvr98.PluginTemplate.listeners.PlayerListener;
import org.bukkit.plugin.java.JavaPlugin;

public final class Main extends JavaPlugin {

    private static JavaPlugin instance;

    @Override
    public void onEnable() {
        instance = this;
        Log.success("Enabling PluginTemplate");

        // Setup plugin with PluginKit
        PluginKit.setPlugin(this)
                 // Commands
                 .addCommand("template", new MyCommand())

                 // Listeners
                 .addListener(new PlayerListener())

                 // Configs
                 .addConfig(new MainConfig())

                 // Tasks
                 // .addTask(new SpawnerSpawnTask())

                 // Hooks
                 // .addHook("Vault", new Vault())

                 // Migrations
                 // .addMigration(new CreatePlayersMigration());

                 // Settings
                 .withSettings(settings -> {
                     // Define your settings here

                     // settings.setMessagesConfig("messages");
                 });

        Log.success("PluginTemplate is enabled");
    }

    @Override
    public void onDisable() {
        Log.success("Disabling PluginTemplate");

        // Disable plugin
        PluginKit.disablePlugin();

        Log.success("PluginTemplate is disabled");
    }

    /**
     * Get plugin instance
     *
     * @return JavaPlugin instance
     */
    public static JavaPlugin getInstance() {
        return instance;
    }

}
